//+------------------------------------------------------------------+
//| Linear Regression                                            
//+------------------------------------------------------------------+
#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  Green
#property  indicator_width1  2

//---- external input
extern int MA_Period = 20;

extern string SymbolY="XAGUSD";
extern string SymbolX="XAUUSD";

//---- indicator buffers
double   rY[], rX[], sqerryYxX[], sqerrxX[], slope[];
//+------------------------------------------------------------------+
//| indicator initialization function                
//+------------------------------------------------------------------+
int init()
  {
//---- indicator buffers mapping
      
   IndicatorBuffers(5);
   SetLevelValue(0,0.0);
   SetIndexBuffer(0,rY);         SetIndexLabel(0,NULL);  SetIndexStyle(0,12);        
   SetIndexBuffer(1,rX);         SetIndexLabel(1,NULL);  SetIndexStyle(1,12);
   SetIndexBuffer(2,sqerryYxX);  SetIndexLabel(2,NULL);  SetIndexStyle(2,12);
   SetIndexBuffer(3,sqerrxX);    SetIndexLabel(3,NULL);  SetIndexStyle(3,12);
   SetIndexBuffer(4,slope);      SetIndexLabel(4,NULL);  SetIndexStyle(4,12);

//---- name for DataWindow and indicator subwindow label
   IndicatorShortName
   ("slopeYX("+SymbolY+","+SymbolX+") slope= "+slope[0]+"");
//---- initialization done
   return(0); 
  }

//+------------------------------------------------------------------+
//| Start function                          
//+------------------------------------------------------------------+
int start()
  {int i;
   slope[i]=slope(i, SymbolY, SymbolX); 
//---- done
   return(0);
  }
  
//+------------------------------------------------------------------+
// Calculating slope
//+------------------------------------------------------------------+
double slope(int i, string symbolY, string symbolX)
   {double meanrY, meanrX, ssYX, ssXX, b;
    int k, limit=i+MA_Period;
    
    for(k=i; k<limit; k++)
   {
    rY[k]       = iClose(symbolY,0,k)/iOpen(symbolY,0,k)-1;
    rX[k]       = iClose(symbolX,0,k)/iOpen(symbolX,0,k)-1; 
   }
    meanrY      = iMAOnArray(rY,0,MA_Period,0,MODE_SMA,i);
    meanrX      = iMAOnArray(rX,0,MA_Period,0,MODE_SMA,i);
    
    for(k=i; k<limit; k++)
   {  
    sqerryYxX[k]= (rX[k]-meanrX)*(rY[k]-meanrY);
    sqerrxX[k]  = MathPow(rX[k]-meanrX,2);
   } 
    ssYX        = iMAOnArray(sqerryYxX,0,MA_Period,0,MODE_SMA,i)*MA_Period;
    ssXX        = iMAOnArray(sqerrxX,0,MA_Period,0,MODE_SMA,i)*MA_Period;
                            
    b           = ssYX/ssXX;                  
    return(b);
   }
   